DlgTextSize  =20
HlpTextSize  =14
DlgTextColor=color.new(0,0,0)
DlgBcgColor=color.new(176,176,176,230)

GuiLightGray=color.new(225,225,225)
GuiMedGray=color.new(206,206,206)
GuiDarkGray=color.new(164,164,164)
dofile("input.lua")
				--name	,image,aligned,number ,status	,onClick(),help
Buttons={ "zoomIn",0		,"right"	,0				,0			,function() if fontSize>=24 then return end fontSize=fontSize+2;SaveData() end,"",
				"zoomOut",0,"right",1,0,function() if fontSize<=12 then return end fontSize=fontSize-2;SaveData() end,"",
				"rotate",0,"right",2,0,function() 	if ScreenOrientation==1 then ScreenOrientation=0 else ScreenOrientation=1 end screen.orientation(ScreenOrientation);ScreenWidth =screen.width();ScreenHeight=screen.height();SaveData() end," ",
				"dayNight",0,"right",3,0,function() local clr=fontColor;fontColor=bcgColor;bcgColor=clr;SaveData() end," ",
				"bookList",0,"center",0,0,function() ListWidget(bookList,4,"",{OpenBook,"",RemoveBook,"",RefreshBook,"  "}) end,"",
				"bookListNew",0,"center",1,0,function() AddBook(Input("  (: voina.txt):")) end,"",
				"start",0,"center",2,1,function()  FirstPage() end," ",
				"end",0,"center",3,1,function()  LastPage() end," ",
				"help",0,"center",4,0,function()   if ShowHelp==true then ShowHelp=false else ShowHelp=true end return false end,"",
				"contents",0,"left",0,1,function() ListWidget(bookList[currentBook+3],2,"",{GotoContent,""}) end," ",
				"bookmarkList",0,"left",1,1,function()  ListWidget(bookList[currentBook+2],2,"",{GotoBookmark,"",RemoveBookmark,""})  end," ",
				"bookmarkListNew",0,"left",2,1,function()  AddBookmark(FirstVisibleLine) end," "
}
function ListWidget(list,elementSize,title,fun)
	local y,yStart,ElementHeight,TextSize,FirstVisibleEl,ResultEl,currentFun
	local BcgColor=color.new(255,255,255)
	TextSize=22;ElementHeight=26;FirstVisibleEl=1;yStart=32;currentFun=1
	local ScrollbarMax,ScrollbarPage,maxScroll
	
	ScrollbarMax=table.getn(list)/elementSize
	ScrollbarPage=math.min(ScrollbarMax,(ScreenHeight-yStart)/ElementHeight)
	maxScroll=math.ceil((ScrollbarMax-ScrollbarPage)*elementSize+1)
	--redraw list
	function Redraw(selection)
		text.color      (DlgTextColor)
		screen.fillrect(0,0,ScreenWidth,ScreenHeight,BcgColor)
		--top bar
		screen.fillrect    (0,0,ScreenWidth,yStart,GuiLightGray)
		screen.drawrect(0,0,ScreenWidth,yStart,GuiMedGray)
		text.size (16)
		text.draw(10,0,title,"left")
		--text.draw(0,0,"Home/power to return to reading","right",ScreenWidth)
		--screen.drawline(64,0,64,yStart,GuiMedGray)
		--func indicator
		if table.getn(fun)>2 then
			y=16
			local i=1
			while i<=table.getn(fun) do
				if currentFun==i then screen.fillrect(y-6,yStart-14,12,12,GuiDarkGray) else screen.fillrect(y-3,yStart-10,6,6,GuiDarkGray) end
				i=i+2
				y=y+16
			end
		end			
		text.size (DlgTextSize)
		text.draw(4,4,fun[currentFun+1],"center")
		y=yStart+2
		text.size(TextSize)
		i=FirstVisibleEl
		while i<=table.getn(list) do
			--screen.drawline(16,y+ElementHeight,ScreenWidth-16,y+ElementHeight,GuiLightGray)
			if(selection==i) then  text.size(TextSize+4); text.draw  (8,y,list[i],"left",0,2); text.size(TextSize);
			else text.draw	(16,y,list[i],"left",0,2) end
			i=i+elementSize;y=y+ElementHeight
			if(y>ScreenHeight) then break end
		end
		--scrollbar
		local ScrollbarThumb=math.max(1,FirstVisibleEl/elementSize)
		local ScrollbarMinThumb=(ScrollbarThumb-1)/ScrollbarMax*(ScreenHeight-yStart)+yStart+1
		local ScrollbarMaxThumb=(ScrollbarThumb-1+ScrollbarPage)/ScrollbarMax*(ScreenHeight-yStart)+yStart+2
		screen.fillrect(ScreenWidth-4,yStart+1,ScreenWidth,ScreenHeight,GuiLightGray)
		screen.fillrect(ScreenWidth-4,ScrollbarMinThumb,ScreenWidth,ScrollbarMaxThumb-ScrollbarMinThumb,GuiDarkGray)
		screen.update()
	end
	Redraw(0)
	--clamping selection
	function ClampListElement(id)
		if id>=maxScroll then return maxScroll end
		if id<1 then return 1 end
		return id
	end
	--event loop
	local SwipeX,SwipeY,CurX,CurY,moving;moving=0
	
	while 1 do
		if control.read()==1 then
			if control.isTouch()==1 then
				if touch.click()==1 then	CurX,CurY=touch.pos()
															if CurY<yStart then currentFun=currentFun+2
																if currentFun>=table.getn(fun) then currentFun=1 end
																Redraw(0)
															else
																	ResultEl=FirstVisibleEl+math.floor((CurY-yStart)/(ElementHeight))*elementSize
																	if ResultEl<table.getn(list) then
																		ResultEl=math.max(1,ResultEl)
																		Redraw(ResultEl)	
																		os.sleep(12)
																		fun[currentFun](ResultEl)
																		return
																	end
															end
				elseif touch.move()==1 then	if moving==0 then SwipeX,SwipeY = touch.pos();moving=1
																	else
																		CurX,CurY=touch.pos()
																		if SwipeY-CurY>2 then FirstVisibleEl=ClampListElement(FirstVisibleEl+elementSize)
																		elseif SwipeY-CurY<-2 then FirstVisibleEl=ClampListElement(FirstVisibleEl-elementSize) end
																		SwipeY=CurY
																		Redraw(0)
																	end
				elseif touch.up()==1    then	moving=0	end
			elseif control.isButton()==1 and  button.click() == 1 then return end
		else
			os.sleep(5)
		end
	end
end
--workaround function about the 1 hour difference bug on Zen
--However on simulator it will show wrong hour
function GetProperTime()
	h=tonumber(os.date("%H"))
	if h==0 then h=23 else h=h-1 end
	return h..os.date(":%M")
end

function MessageDialog(msg,wait)
	screen.fillrect(0,0,ScreenWidth,ScreenHeight,bcgColor)
	text.size   (24)
	text.color(fontColor)
	local y=ScreenHeight/2-24
	for line in msg:gmatch("([^\n]+)[\n]*") do 
		text.draw(0,y,line,"center",ScreenWidth,2);y=y+24
	end
	screen.update()
	if wait~=nil and wait~=false then
		os.sleep(120)
	end
end

ShowHelp=false
function MainMenu()
	local status,reslt
	status,reslt=xpcall(MainMenuInt,function(errobj) MessageDialog("Error caught in main menu! App will now exit..",true) end)
	if status==true then return reslt else return true end
end
function MainMenuInt()
	ShowHelp=false
	function ButtonsIterator(cb)
		local x,y
		local i=1
		while i<table.getn(Buttons) do
				if Buttons[i+2]=="right" then
					x=ScreenWidth-46 
					y=(Buttons[i+3]*46)+(ScreenHeight-4*46)/2
				elseif Buttons[i+2]=="center" then
					x=(Buttons[i+3]*46)+(ScreenWidth-5*46)/2
					y=ScreenHeight-46 
				elseif Buttons[i+2]=="left" then
					x=0
					y=(Buttons[i+3]*46)+(ScreenHeight-3*46)/2
				end
				if cb(i,x,y)==true then break end 
			i=i+7
		end
	end
	--load button images
	ButtonsIterator(function (btn,x,y)
						Buttons[btn+1]=image.load("res/"..Buttons[btn]..".png")
					end)
	--redraw buttons
	function Redraw()
		local hx,hw
		text.size   (DlgTextSize)
		text.color(DlgTextColor)
		screen.fillrect(0,0,ScreenWidth,ScreenHeight,DlgBcgColor)
		if currentBook==0 then
			text.draw          (0,0,"    "..GetProperTime(),"center")
		else
			text.draw          (0,0,bookList[currentBook].."  "..BookPercentage().."  "..GetProperTime(),"center")
		end
		if ShowHelp==true then
			text.size   (HlpTextSize)
			text.draw          (0,24,"   ,   ","center")
			text.draw          (0,36," Home/Power  ","center")
			text.draw          (0,54,"  :","center")
			text.draw          (0,66,"  ,    . ","center")
			text.draw          (0,78," home,    . ","center")
			text.draw          (0,90," home,    ","center")
			text.draw          (0,110,"Eread 1.0","center")
			text.draw          (0,122,"www.zenx-fi2.my1.ru","center")
		end
		ButtonsIterator(function (btn,x,y)
						if Buttons[btn+4]==1 and currentBook==0 then return end
						if Buttons[btn+4]==2 then
							image.draw(Buttons[btn+1],x-8,y-8,62,62)
							Buttons[btn+4]=0
						else image.draw(Buttons[btn+1],x,y,46,46) end
						if ShowHelp==true then--show help?
							y=y-8
							if Buttons[btn+2]=="center" then hx=x;hw=x+46;y=y-10 else hx=0;hw=ScreenWidth; end
							for word in Buttons[btn+6]:gmatch("[%s]*([^%s]+)") do 
									text.draw(hx,y,word,Buttons[btn+2],hw);y=y+10
							end
						end
		end)
		screen.update()
	end
	Redraw()
	--event loop
	local xt,yt,result
	while 1 do
		if control.read()==1 then
			if control.isTouch()==1 and touch.click()==1 then
				result=true
				xt,yt=touch.pos()
				ButtonsIterator(function (btn,x,y)
						if Buttons[btn+4]==1 and currentBook==0 then return end
						if xt>=x and yt>=y and xt<x+46 and yt<y+46 then xt=Buttons[btn+4];Buttons[btn+4]=2;Redraw();os.sleep(12);if Buttons[btn+5]()==nil then result=true else result=false end Buttons[btn+4]=xt return true end
				end)
				if result==true then result=false break else Redraw() end
			elseif control.isButton()==1 and button.click() == 1  then	result=true	break	end    
		else
			os.sleep(5)
		end
	end
	--dispose of button images
	ButtonsIterator(function (btn,x,y)
						image.close(Buttons[btn+1])
					end)
	return result
end
